film/urls.py
from django.urls import path

from . import views

app_name = 'film'

urlpatterns = [
    # path('', views.index, name='list'),
    path('', views.FilmView.as_view(), name='list'),
    # path('detail/<int:pk>', views.detail, name='detail'),
    path('detail/<int:pk>', views.FilmDetailView.as_view(), name='detail'),
    # path('create-form/', views.create_form, name='list'),
    path('create-form/', views.AddFilmView.as_view(), name='add'),
    # path('edit-form/<int:pk>', views.edit_form, name='list'),
    path('edit-form/<int:pk>', views.UpdateFilmView.as_view(), name='update'),

    path('delete/<int:pk>', views.DeleteFilmView.as_view(), name = 'delete')
]

sipi/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf.urls.static import static
from django.conf import settings


urlpatterns = [
    path('admin/', admin.site.urls),
    path('berita/', include('berita.urls')),
    path('ulasan/', include('ulasan.urls')),
    path('', include('home.urls')),
    path('', include('watchlist.urls')),
    path('', include('forum.urls')),
    path('film/', include('film.urls')),
    path('account/', include('account.urls')),
]

urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

ulasan/urls.py
from django.urls import path

from . import views

app_name = 'ulasan'

urlpatterns = [
    path('seeulasan/<int:pk>', views.seeulasan, name='seeulasan'),
    path('formulasan/<int:pk>', views.makereview, name='formulasan'),
    path('updateulasan/<int:pk>', views.updatereview, name='updateulasan'),
    path('confdeleulasan/<int:pk>', views.deletereview, name='deleteulasan'),
]

watchlist/urls.py
from django.urls import path
from . import views

app_name = 'watchlist'

urlpatterns = [
    path('watchlist/', views.get_watchlist, name='get_watchlist'),
    path('watchlistfilm/<int:pk>/tambah_episode_tertonton/', views.tambah_episode_tertonton, name='tambah_episode_tertonton'),
    path('watchlistfilm/<int:pk>/kurang_episode_tertonton/', views.kurang_episode_tertonton, name='kurang_episode_tertonton'),
    path('watchlistfilm/<int:pk>/hapus', views.delete_watchlist_film, name="delete_watchlist_film"),
    path('watchlistfilm/<int:pk>/update_status_menonton', views.update_status_menonton_watchlist_film, name='update_status_menonton'),
    path('watchlist/tambah_film/<int:film_pk>', views.tambah_film, name="tambah_film_watchlist"),
    path('watchlist/batalkan_tambah_film/<int:film_pk>', views.batalkan_tambah_film, name='batalkan_tambah_film')
]

watchlist/models.py
from django.core.validators import MaxValueValidator, MinValueValidator
from django.db import models
from account.models import User
from film.models import Film

class Watchlist(models.Model):
    user = models.OneToOneField(User, on_delete=models.CASCADE, default=None) # Silakan ditambah argumennya nanti

class WatchlistFilm(models.Model):
    film = models.ForeignKey(Film, on_delete=models.CASCADE)
    watchlist = models.ForeignKey(Watchlist, on_delete=models.CASCADE)
    skor_ulasan = models.IntegerField(
        default = 0,
        validators = [
            MaxValueValidator(10),
            MinValueValidator(0)
        ]
    )
    status_menonton = models.BooleanField(default = False)
    jml_episode_tertonton = models.IntegerField(default = 0)

watchlist/forms.py
from django import forms
from .models import WatchlistFilm

class WatchlistFilmStatusForm(forms.ModelForm):
    class Meta:
        model = WatchlistFilm
        fields = ['status_menonton']
        widgets = {
             'status_menonton' : forms.Select(attrs={'class': 'custom-select', 'id': 'inputGroupSelect01'}, choices=[('True', 'Sudah selesai'), ('False', 'Belum Selesai')]),
        }
        

class WatchlistFilmSkorForm(forms.ModelForm):
    class Meta:
        model = WatchlistFilm
        fields = ['skor_ulasan']

watchlist/views.py
from django.contrib import messages
from django.contrib.auth.decorators import login_required
from django.http import request
from django.http.response import HttpResponseRedirect
from django.shortcuts import render
from django.urls import reverse_lazy
from .models import Watchlist, WatchlistFilm
from .forms import WatchlistFilmSkorForm, WatchlistFilmStatusForm
from film.models import Film

@login_required(login_url='account:login')
def get_watchlist(request):
    watchlist = Watchlist.objects.get(user=request.user)
    watchlist_films = WatchlistFilm.objects.filter(watchlist=watchlist.pk)
    update_status_form = WatchlistFilmStatusForm(request.POST or None)

    if request.method == 'GET':
        response = {
            'watchlist': watchlist,
            'watchlist_films': watchlist_films,
            'update_status_form': update_status_form,
        }
        return render(request, 'index.html', response)

@login_required(login_url='account:login')
def update_status_menonton_watchlist_film(request, pk):
    watchlist_film = WatchlistFilm.objects.get(pk=pk)

    if request.method == 'POST':
        status_menonton = request.POST.get('status_menonton')
        print
        if status_menonton == 'Sudah':
            watchlist_film.status_menonton = True
        else:
            watchlist_film.status_menonton = False

        watchlist_film.save()
        
        return HttpResponseRedirect('/watchlist/')

@login_required(login_url='account:login')
def update_skor_ulasan_watchlist_film(request, pk):
    watchlist_film = WatchlistFilm.objects.get(pk=pk)
    form = WatchlistFilmSkorForm(request.POST or None, instance=watchlist_film)

    if request.method == 'POST' and form.is_valid():
        form.save()
        return HttpResponseRedirect() # Silakan ganti dengan halaman yang diinginkan

@login_required(login_url='account:login')
def delete_watchlist_film(request, pk):
    watchlist_film = WatchlistFilm.objects.get(pk=pk)
    
    if request.method == 'POST':
        watchlist_film.delete()
        return HttpResponseRedirect('/watchlist/')

@login_required(login_url='account:login')
def tambah_episode_tertonton(request, pk):
    watchlist_film = WatchlistFilm.objects.get(pk=pk)

    if request.method == 'POST':
        watchlist_film.jml_episode_tertonton += 1
        watchlist_film.save()
        return HttpResponseRedirect('/watchlist/')

@login_required(login_url='account:login')
def kurang_episode_tertonton(request, pk):
    watchlist_film = WatchlistFilm.objects.get(pk=pk)

    if request.method == 'POST':
        watchlist_film.jml_episode_tertonton -= 1
        watchlist_film.save()
        return HttpResponseRedirect('/watchlist/')

@login_required(login_url='account:login')
def tambah_film(request, film_pk):
    film = Film.objects.get(pk=film_pk)
    watchlist = Watchlist.objects.get(user=request.user)
    
    if request.method == 'POST':
        watchlist_film = WatchlistFilm(film=film, watchlist=watchlist)
        watchlist_film.save()

        messages.add_message(request, messages.SUCCESS, "Film berhasil ditambahkan.")

        return HttpResponseRedirect('/film/detail/' + str(film_pk))

@login_required(login_url='account:login')
def batalkan_tambah_film(request, film_pk):
    film = Film.objects.get(pk=film_pk)
    watchlist = Watchlist.objects.get(user=request.user)
    
    if request.method == 'POST':
        watchlist_film = WatchlistFilm.objects.filter(film=film, watchlist=watchlist)
        watchlist_film.delete()

        messages.add_message(request, messages.INFO, "Aksi dibatalkan.")

        return HttpResponseRedirect('/film/detail/' + str(film_pk))

watchlist/templates/index.html
{% extends 'base.html' %}
{% load static %}

{% block css %}
    <link rel='stylesheet' href="{% static 'watchlist/css/style.css' %}">
{% endblock css %}

{% block content %}
    <div class="watchlist-main">
        <h1 id="header">Watchlist</h1>
        <div class="watchlist-content">
            
            {% for watchlist_film in watchlist_films %}

                <!-- Delete Confirmation Message Modal -->
                <div class="modal fade" id="delete_modal_{{ watchlist_film.pk }}" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
                    <div class="modal-dialog">
                        <div class="modal-content">
                            <div class="modal-header">
                                <h5 class="modal-title" id="exampleModalLabel">Konfirmasi</h5>
                                <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                            </div>
                            <div class="modal-body">
                            <p>Apakah anda yakin ingin menghapus {{ watchlist_film.film.judul_film }} dari watchlist?</p>
                            </div>
                            <div class="modal-footer">
                                <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Batalkan</button>
                                <form action="{% url 'watchlist:delete_watchlist_film' watchlist_film.pk %}" method="post">
                                    {% csrf_token %}
                                    <button type="submit" class="btn btn-primary">Hapus</button>
                                </form>
                            </div>
                        </div>
                    </div>
                </div>

                <!-- Ubah Status Modal -->
                <div class="modal fade" id="status_modal_{{ watchlist_film.pk }}" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
                    <div class="modal-dialog">
                        <div class="modal-content">
                            <div class="modal-header">
                                <h5 class="modal-title" id="exampleModalLabel">Ubah Status</h5>
                                <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                            </div>
                            <form action="{% url 'watchlist:update_status_menonton' watchlist_film.pk %}" method="post">
                                {% csrf_token %}
                                <div class="modal-body">
                                    <div class="input-group mb-3">
                                        <div class="input-group-prepend">
                                            <label class="input-group-text" for="inputGroupSelect01">Status:</label>
                                        </div>
                                        <select class="custom-select" id="inputGroupSelect01" name="status_menonton">
                                            <option selected disabled>Pilih...</option>
                                            <option value="Belum">Belum Selesai</option>
                                            <option value="Sudah">Sudah Selesai</option>
                                        </select>
                                    </div>
                                </div>
                                <div class="modal-footer">
                                    <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Batalkan</button>
                                    <button type="submit" class="btn btn-primary">Ubah</button>
                                </div>
                            </form>
                        </div>
                    </div>
                </div>

                <div class="watchlist-card">
                    <div class="watchlist-card-left">
                        <img class="watchlist-thumbnail" src="{{ watchlist_film.film.poster }}">
                    </div>
                    <div class="watchlist-card-right">
                        <div class="watchlist-card-right-top">
                            <p id="title">{{ watchlist_film.film.judul_film }}</p>
                            {% if watchlist_film.status_menonton %}
                                <p id="status-menonton">Sudah Selesai</p>
                            {% else %}
                                <p id="status-menonton">Belum Selesai</p>
                            {% endif %}
                        </div>
                        <div class="watchlist-card-right-bottom">
                            <div class="watchlist-card-episode">
                                <p id="episode-tertonton">Episode tertonton:</p>
                                <div class="watchlist-card-episode-bottom">
                                    <p id="episode-count">{{ watchlist_film.jml_episode_tertonton }}/{{ watchlist_film.film.jumlah_episode }}</p>
                                    <div class="watchlist-card-episode-buttons">
                                        {% if watchlist_film.jml_episode_tertonton != watchlist_film.film.jumlah_episode %}
                                            <form action="{% url 'watchlist:tambah_episode_tertonton' watchlist_film.pk %}" method="post">
                                                {% csrf_token %}
                                                <button type="submit" class="button button-green button-small">+</button>
                                            </form>
                                        {% endif %}
                                        {% if watchlist_film.jml_episode_tertonton != 0 %}
                                            <form action="{% url 'watchlist:kurang_episode_tertonton' watchlist_film.pk %}" method="post">
                                                {% csrf_token %}
                                                <button type="submit" class="button button-red button-small">-</button>
                                            </form>
                                        {% endif %}
                                    </div>
                                </div>
                            </div>
                            <div class="watchlist-card-buttons">
                                <button class="button button-green" data-bs-toggle="modal" data-bs-target="#status_modal_{{ watchlist_film.pk }}">Ubah Status</button>
                                <form action="{% url 'ulasan:formulasan' watchlist_film.film.pk %}" method="post">
                                    {% csrf_token %}
                                    <button type="submit" class="button button-green" href="">Berikan Ulasan</button>
                                </form>
                                <button class="button button-red" data-bs-toggle="modal" data-bs-target="#delete_modal_{{ watchlist_film.pk }}">Hapus</button>
                            </div>
                        </div>
                    </div>
                </div>
            {% endfor %}
           
        </div>
    </div>
{% endblock content %}
    